#!/bin/sh
#-----------------------------------------------
#procedure pour generer une template vz
#-----------------------------------------------
RPM="rpm"
ARCH=i686
#-----------------------------------------------
#storage host
SAFEHOST=locrepo.safe.ca
#------------------------------------------------
abort ()

{
echo Trouble!: $*
exit 1
}
#------------------------------------------------
#mounting system partition
#$1 mount/umount
montedemonte()

{
case "$1" in
  "mount"	)
    $CHROOT $VE_ROOT mount -t proc proc /proc 
    $CHROOT $VE_ROOT mount -t sysfs sysfs /sys 
    ;;
  "umount"	)
    $CHROOT $VE_ROOT umount /sys 
    $CHROOT $VE_ROOT umount /proc 
    ;;
  esac
}
#------------------------------------------------
#makint a chroot space
makechroot()

{
mkdir -p $1
(
cd $1
mkdir -p var/lib/yum
mkdir -p var/lib/rpm
mkdir -p var/lock/rpm
mkdir -p var/lock/subsys

#preparing proc sys 
mkdir -p proc sys
#preparing dev dir
mkdir -p dev/pts dev/shm
mknod --mode 0666 dev/null c 1 3
mknod --mode 0666 dev/ptmx c 5 2
mknod --mode 0444 dev/random c 1 8
mknod --mode 0444 dev/urandom c 1 9
mknod --mode 0444 dev/initctl p


#preparing file fstab
mkdir -p etc
touch etc/fstab
touch etc/mtab
chmod 0644 etc/fstab
(
echo -e "tmpfs\t/dev/shm\ttmpfs\tdefaults\t0 0"
echo -e "devpts\t/dev/pts\tdevpts\tgid=5,mode=620\t0 0"
echo -e "sysfs\t/sys\t\tsysfs\tdefaults\t0 0"
echo -e "proc\t/proc\t\tproc\tdefaults\t0 0"
) >> etc/fstab

)

#preparing RPM data-base
$RPM --root $1 --initdb
}

#------------------------------------------------
#extracting variable
if [ -z "$1" ] ; then
  abort "you need to specify version"
  exit 1;
  fi;
#defining local Variable
#------------------------------------------------
LOS=`echo $1 | cut -d'-' -f1`
DIST=`echo $1 | cut -d'-' -f2`
ARCH=`echo $1 | cut -d'-' -f3`
VZTYPE=`echo $1 | cut -d'-' -f4`
BASE=/vz/template/$LOS/$DIST/$ARCH/config
ADDONS=/vz/template/$LOS/$DIST/$ARCH/vz-addons
CACHEDIR=/vz/template/cache
TARBALL=$1.tar.gz
VE_ROOT=/vz/tmp/tpl1-$DIST-$ARCH
CHROOT="/usr/bin/setarch $ARCH /usr/sbin/chroot"
echo "Mission lift-off ($LOS, $DIST, $ARCH, $VZTYPE)"
#------------------------------------------------
#cleaning first (in case)
umount -l $VE_ROOT/proc > /dev/null 2>&1
umount -l $VE_ROOT/sys > /dev/null 2>&1
rm -fr $VE_ROOT
#------------------------------------------------
#preparing first stage install
echo "First Stage Ignition"
set -e
set -u
makechroot $VE_ROOT

#adding LOCAL rpm to the storage area
mkdir -p $VE_ROOT/tmp/rpm1

#installing only Very basic RPM
#DUMMIES="dummyker MAKEDEV"
DUMMIES=""
RPMEXTRA=""
COREBASE=""
EXCLUDED=""
case "$DIST" in 
  "rh8.0"	|			\
  "rh7.3"	)
    COREBASE="mount textutils"
    ;;
  "mdv2010.1"	)			
    COREBASE="util-linux-ng filesystem"
    EXCLUDED="man-pages*"
    ;;
  "mdv2006"	)			
    COREBASE="mount coreutils setup makedev filesystem"
    ;;
  "rhel3"	|			\
  "rh9"	)
    COREBASE="mount coreutils"
    ;;
  "sl6.0"	|			\
  "fc15"	|			\
  "fc7"		|			\
  "fc6"		|			\
  "fc5"		|			\
  "fc4"		|			\
  "fc3"		|			\
  "fc2"		|			\
  "el6.3"	|			\
  "el6.2"	|			\
  "el6.1"	|			\
  "el6.0"	|			\
  "el5.8"	|			\
  "el5.7"	|			\
  "el5.6"	|			\
  "el5.5"	|			\
  "el5.4"	|			\
  "el5.3"	|			\
  "el5.2"	|			\
  "el4.9"	|			\
  "el4.8"	|			\
  "el4.7"	|			\
  "el4.6"	|			\
  "rhel4"	)
    COREBASE="util-linux coreutils"
    ;;
  "fc14"	|			\
  "fc13"	|			\
  "fc12"	|			\
  "fc11"	|			\
  "fc10"	|			\
  "fc9"		|			\
  "fc8"	)
    COREBASE="util-linux-ng coreutils"
    ;;
  "*"		)
    ;;
  esac
(
yum -y install				\
 	--downloadonly 			\
	--downloaddir=$VE_ROOT/tmp/rpm1	\
	--installroot=$VE_ROOT		\
	-c $BASE/yum.conf 		\
	$COREBASE $DUMMIES rpm || true
)
#to makes ure dummies RPM are downloaded properly
for dummy in $DUMMIES
  do
  cp -a $ADDONS/$dummy*.rpm $VE_ROOT/tmp/rpm1
  done

#to make sure we have basic utilities available
#regardless dependcy errors
if [ -n "$RPMEXTRA" -o "$COREBASE" ] ; then
  for direct in $RPMEXTRA $COREBASE
    do
    (cd $VE_ROOT ; rpm2cpio tmp/rpm1/$direct*.rpm | cpio --quiet -id)
    done
  fi
($RPM -ihv --root $VE_ROOT $VE_ROOT/tmp/rpm1/*.rpm || true)

#rebuild RPM under the Distribution architecture
echo "First Stage shut-off"
#------------------------------------------------
#second stage install
echo "Second Stage Ignition"
TOGET=`cat $BASE/full.list | egrep -v '^#|^[[:space:]]*$'`

case "$DIST" in
  "rh9"		|				\
  "rhel3"	)
    echo > $VE_ROOT/etc/mtab
    ;;
  "rhel4"	|				\
  "fc4"		|				\
  "fc3"		|				\
  "el4.9"	|				\
  "el4.8"	|				\
  "el4.7"	|				\
  "el4.6"	)
    $CHROOT $VE_ROOT umount /proc
    echo "/dev/simfs    /       simfs   rw      0 0" >> $VE_ROOT/etc/mtab
    ;;
  "*"		)
    echo "/dev/simfs	/	simfs	rw	0 0" >> $VE_ROOT/etc/mtab
    ;;
  esac


montedemonte mount
#preparing second stage RPM DB
(
yum -y install				\
 	--downloadonly 			\
	--downloaddir=$VE_ROOT/tmp/rpm2	\
	--installroot=$VE_ROOT		\
	-c $BASE/yum.conf 		\
	$TOGET || true
)
#cleaning stage I previously installed RPM
for deja in `ls $VE_ROOT/tmp/rpm1`
  do
  rm -f $VE_ROOT/tmp/rpm2/`basename $deja`
  done

#removing not need package
if [ -n "$EXCLUDED" ] ; then
  for notneeded in $EXCLUDED
    do
    rm -fr $VE_ROOT/tmp/rpm2/$notneeded
    done
  fi

#installing remaining RPMs
($RPM -ihv --root $VE_ROOT $VE_ROOT/tmp/rpm2/*.rpm || true)

#switching to the Distribution RPM structure
rm -fr $VE_ROOT/var/lib/rpm/*
$CHROOT $VE_ROOT $RPM --initdb
$CHROOT $VE_ROOT $RPM -ihv --nodeps --justdb --quiet	\
			/tmp/rpm1/*.rpm			\
			/tmp/rpm2/*.rpm


#cleaning up
rm -fr $VE_ROOT/tmp/rpm*

montedemonte umount 
echo "Second Stage Shut-off"
#------------------------------------------------
#preparing service
echo "Third Stage Ignition"

montedemonte mount

#adjusting library
case "$DIST" in 
  "mdv2006"	)
    ( 
    cd  $VE_ROOT/usr/lib
    ln -s libbz2.so.1 libbz2.so
    ln -s ../../lib/libpam.so.0 libpam.so
    )
    ;;
  "mdv2010.1"	)
    ( 
    cd  $VE_ROOT/usr/lib
    ln -s libgmp.so.10 libgmp.so
    cd $VE_ROOT/sbin
    cp resolvconf resolvconf.ref
    (
    echo "!# /bin/sh"
    echo "exit 0"
    ) > resolvconf
    )
    ;;
  *		)
    ;;
  esac
# Set the same timezone as for host system
test -f /etc/localtime && cp -fp /etc/localtime $VE_ROOT/etc/localtime

#creating dev directory
DEVDIR="/dev"
case "$DIST" in 
  "sl6.0"	|						\
  "el6.3"	|						\
  "el6.2"	|						\
  "el6.1"	|						\
  "el6.0"	)
    sed -i -e"s/^console output/#console output/" $VE_ROOT/etc/init/rc.conf
    sed -i -e"s/^console output/#console output/" $VE_ROOT/etc/init/rcS.conf
    rm -fr $VE_ROOT/sbin/*udev*
    rm -fr $VE_ROOT/etc/init/tty.conf
    rm -fr $VE_ROOT/etc/init/start-ttys.conf
    ;;
  "fc15"	|						\
  "fc14"	|						\
  "fc13"	)
    sed -i -e"s/^console output/#console output/" $VE_ROOT/etc/init/rc.conf
    sed -i -e"s/^console output/#console output/" $VE_ROOT/etc/init/rcS.conf
    ;;
  *		)
    # Disable klogd on syslog or rsyslog
    if [ -f etc/init.d/syslog ] ; then
      sed -i \
	-e 's/daemon\\ klogd/passed\\ klogd\\ skipped/' \
	-e 's/killproc\\ klogd/passed\\ klogd\\ skipped/' \
	etc/init.d/syslog 
      fi
    if [ -f etc/init.d/rsyslog ] ; then
      sed -i \
	-e 's/daemon\\ rklogd/passed\\ rklogd\\ skipped/' \
	-e 's/killproc\\ rklogd/passed\\ rklogd\\ skipped/' \
	etc/init.d/rsyslog
      fi
    rm -fr $VE_ROOT/sbin/*udev*
    ;;
  esac
mkdir -p $VE_ROOT/$DEVDIR
rm -fr $VE_ROOT/$DEVDIR/[a-z]*
(
mknod -m 666 $VE_ROOT/$DEVDIR/console c 5 1
mknod -m 666 $VE_ROOT/$DEVDIR/tty c 5 0
cd /dev
cp -a 					\
	core full kmem kmsg mem null	\
	port ptmx			\
	random urandom zero		\
	ttya[0-9] ttya[a-f]		\
	ttyp[0-7]			\
	ptya[0-9] ptya[a-f]		\
	ptyp[0-8] 			\
	ram[0-1] 			\
	$VE_ROOT/$DEVDIR
cd $VE_ROOT/$DEVDIR
ln -s ram0 ramdisk
ln -s ram1 ram
ln -s /proc/self/fd fd
ln -s /proc/self/fd/0 stdin
ln -s /proc/self/fd/1 stdout
ln -s /proc/self/fd/2 stderr
mkdir pts
)
#gettig ride of /etc/sysctl.conf
> $VE_ROOT/etc/sysctl.conf

#to get rid of not needed mingetty
rm -f $VE_ROOT/etc/event.d/tty*

# Turn not needed services off
OFF_SERVICES="gpm anacron portmap netfs"
# Add the following "unneeded" services well if you managed to install it:
#   gpm
#   lm_sensors
for S in $OFF_SERVICES; do
  $CHROOT $VE_ROOT /sbin/chkconfig --list $S >/dev/null 2>&1 &&
    $CHROOT $VE_ROOT /sbin/chkconfig $S off > /dev/null 2>&1 
  done

# Turn needed services on
ON_SERVICES="network httpd iptables xinetd"
for S in $ON_SERVICES; do
  $CHROOT $VE_ROOT /sbin/chkconfig --list $S >/dev/null 2>&1 &&
    $CHROOT $VE_ROOT /sbin/chkconfig $S on > /dev/null 2>&1
  done

# Convert system to shadow password files
$CHROOT $VE_ROOT /usr/sbin/pwconv

# Disable root login
$CHROOT $VE_ROOT /usr/sbin/usermod -L root

(
#ajusting ALL services
cd $VE_ROOT
# Do not launch *getty on tty devices - they are not accessible from VPS
if [ -f etc/inittab ] ; then
  sed -i -e '/getty/d' etc/inittab
  fi
rm -fr event.d/tty*


# Do not execute some cron-jobs by default
# We do not care if some files are missing
#for filecron in `ls etc/cron.daily/*`
#  do
#  if [ -f $filecron ] ; then
#   chmod a-x $filecron
#   fi
#  done

# Mount /dev/pts
# FIXME is that needed in 2.6 kernel?
#echo "none     /dev/pts        devpts  rw      0 0" >> etc/fstab

# Disable fsync() in syslog or rsyslog
if [ -f etc/syslog.conf ] ; then
  sed -i \
	-e 's@\\\([[:space:]]\\\)\\\(/var/log/\\\)@\\\1-\\\2@' \
	etc/syslog.conf
  fi

if [ -f etc/rsyslog.conf ] ; then
  sed -i \
	-e 's@\\\([[:space:]]\\\)\\\(/var/log/\\\)@\\\1-\\\2@' \
	etc/rsyslog.conf
  fi

# Disable X11Forwarding by default
sed -i \
	-e "s/^X11Forwarding.*$/X11Forwarding\\ no/"  \
	etc/ssh/sshd_config


# Do not try to unload iptables modules
if [ -f etc/sysconfig/iptables-config ] ; then
  sed -i \
	-e 's@^IPTABLES_MODULES_UNLOAD.*@IPTABLES_MODULES_UNLOAD="no"@' \
	etc/sysconfig/iptables-config
  fi

# Disable nmbd in Samba (does not work in VPS)
if [ -f etc/init.d/smb ] ; then
  sed -i \
        -e s"@^.*nmbd.*\\\$@\\#\\ \\&@" \
        etc/init.d/smb
  fi

# Link /etc/mtab to /proc/mounts
rm -f etc/mtab
ln -s /proc/mounts etc/mtab

# Set non-interactive mode for initscripts (openvz bug #46)
if [ -f etc/sysconfig/init ] ; then
  sed -i -e "s@^PROMPT=.*@PROMPT=no@"  etc/sysconfig/init
  fi

(
#updating route information (needed by RH-8.0)
if [ -x etc/sysconfig/networking/devices ] ; then
  cd etc/sysconfig/networking/devices
  ln -s ../../network-scripts/route-venet0 venet0.route
  fi
)

#creating skelrpm structure
mkdir -p etc/skelrpm
cp -a etc/skel/.[A-z]* etc/skelrpm
cat > etc/skelrpm/.rpmmacros << EOT
#RPM macros definition definition
#top directory
%__cpl_user     %(id -u -n)
%_topdir        /home/%{__cpl_user}/RPM
%_tmppath       /home/%{__cpl_user}/RPM/tmp
EOT
for d in BUILD RPMS SOURCES SPECS SRPMS tmp
  do
  mkdir -p etc/skelrpm/RPM/$d
  done
)

# resetting log fonction
for ser in syslog rsyslog snmpd
  do
  if [ -f $VE_ROOT/etc/init.d/$ser ] ; then
    $CHROOT $VE_ROOT /sbin/chkconfig --del $ser > /dev/null 2>&1
    $CHROOT $VE_ROOT /sbin/chkconfig --add $ser > /dev/null 2>&1
    $CHROOT $VE_ROOT /sbin/chkconfig $ser on > /dev/null 2>&1
    fi
  done

#umounting /proc/ directory
montedemonte umount

rm -f $VE_ROOT/dev/log

echo "Third Stage Shut-off"
#------------------------------------------------
#building tar
echo "Packing distribution to $TARBALL"
(
cd $VE_ROOT
tar --numeric-owner -zcf $CACHEDIR/$TARBALL . || abort "tar failed"
)
scp $CACHEDIR/$TARBALL safe@$SAFEHOST:/var/ftp/pub/linux/vztemplate
rm $CACHEDIR/$TARBALL

#------------------------------------------------
#finale cleanup
mv $VE_ROOT $VE_ROOT.$$
rm -fr $VE_ROOT.$$ &
#------------------------------------------------

